Index: branches/2213_irace/HeuristicLab.Integration.Irace/2.4/HeuristicLab.Integration.Irace-2.4.csproj
===================================================================
--- branches/2213_irace/HeuristicLab.Integration.Irace/2.4/HeuristicLab.Integration.Irace-2.4.csproj	(revision 16102)
+++ branches/2213_irace/HeuristicLab.Integration.Irace/2.4/HeuristicLab.Integration.Irace-2.4.csproj	(revision 16102)
@@ -0,0 +1,80 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="15.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{8B6E1459-EC93-46CB-B795-D175F834488D}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Integration.Irace</RootNamespace>
+    <AssemblyName>HeuristicLab.Integration.Irace-2.4</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\bin</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\bin</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="HiveTargetRunner.cs" />
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{a9ad58b9-3ef9-4cc1-97e5-8d909039ff5c}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
+      <Project>{94186a6a-5176-4402-ae83-886557b53cca}</Project>
+      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: branches/2213_irace/HeuristicLab.Integration.Irace/2.4/HiveTargetRunner.cs
===================================================================
--- branches/2213_irace/HeuristicLab.Integration.Irace/2.4/HiveTargetRunner.cs	(revision 16102)
+++ branches/2213_irace/HeuristicLab.Integration.Irace/2.4/HiveTargetRunner.cs	(revision 16102)
@@ -0,0 +1,42 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.IO;
+using System.Linq;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Integration.Irace {
+  [Application("Irace Hive Target Runner", "Loads an algorithm file and runs it as a Hive job.")]
+  public class HiveTargetRunner : ApplicationBase {
+    public override void Run(ICommandLineArgument[] args) {
+      var output = args.OfType<SimpleArgument>().Single(x => x.Key == "stdout");
+      using (var file = File.CreateText(output.Value)) {
+        var arg = args.OfType<SimpleArgument>().SingleOrDefault(x => x.Key == "iraceRun");
+        if (arg != null) {
+          file.WriteLine(arg.Value);
+          file.Flush();
+        }
+        Environment.Exit(0);
+      }
+    }
+  }
+}
Index: branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Plugin.cs
===================================================================
--- branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Plugin.cs	(revision 16102)
+++ branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Plugin.cs	(revision 16102)
@@ -0,0 +1,33 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Integration.Irace {
+  [Plugin("HeuristicLab.Integration.Irace", "2.4.0.0")]
+  [PluginFile("HeuristicLab.Integration.Irace-2.4.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  public class HeuristicLabMainFormPlugin : PluginBase {
+  }
+}
Index: branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Plugin.cs.frame
===================================================================
--- branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Plugin.cs.frame	(revision 16102)
+++ branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Plugin.cs.frame	(revision 16102)
@@ -0,0 +1,33 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Integration.Irace {
+  [Plugin("HeuristicLab.Integration.Irace", "2.4.0.$WCREV$")]
+  [PluginFile("HeuristicLab.Integration.Irace-2.4.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  public class HeuristicLabMainFormPlugin : PluginBase {
+  }
+}
Index: branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Properties/AssemblyInfo.cs
===================================================================
--- branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Properties/AssemblyInfo.cs	(revision 16102)
+++ branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Properties/AssemblyInfo.cs	(revision 16102)
@@ -0,0 +1,56 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Integration.Irace")]
+[assembly: AssemblyDescription("Provides target runner, target evaluator and cluster status applications to be called by irace.")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2018 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("8b6e1459-ec93-46cb-b795-d175f834488d")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("2.4.0.0")]
+[assembly: AssemblyFileVersion("2.4.0.0")]
Index: branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Properties/AssemblyInfo.cs.frame	(revision 16102)
+++ branches/2213_irace/HeuristicLab.Integration.Irace/2.4/Properties/AssemblyInfo.cs.frame	(revision 16102)
@@ -0,0 +1,56 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Integration.Irace")]
+[assembly: AssemblyDescription("Provides target runner, target evaluator and cluster status applications to be called by irace.")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2018 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("8b6e1459-ec93-46cb-b795-d175f834488d")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("2.4.0.0")]
+[assembly: AssemblyFileVersion("2.4.0.$WCREV$")]
Index: branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/CommandLineArgumentHandling/Arguments/SimpleArgument.cs
===================================================================
--- branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/CommandLineArgumentHandling/Arguments/SimpleArgument.cs	(revision 16102)
+++ branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/CommandLineArgumentHandling/Arguments/SimpleArgument.cs	(revision 16102)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.PluginInfrastructure {
+  [Serializable]
+  public class SimpleArgument : CommandLineArgument<string> {
+    public string Key { get; private set; }
+
+    public SimpleArgument(string key, string value) : base(value) {
+      Key = key;
+    }
+
+    protected override bool CheckValidity() {
+      return true;
+    }
+  }
+}
Index: branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/CommandLineArgumentHandling/CommandLineArgumentHandling.cs
===================================================================
--- branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/CommandLineArgumentHandling/CommandLineArgumentHandling.cs	(revision 16101)
+++ branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/CommandLineArgumentHandling/CommandLineArgumentHandling.cs	(revision 16102)
@@ -43,5 +43,5 @@
 
     private static ICommandLineArgument ParseArgument(string entry) {
-      var regex = new Regex(@"^/[A-Za-z]+(:\w[\w\s]*)?$");
+      var regex = new Regex(@"^/[A-Za-z]+(:[^/]*)?$");
       bool isFile = File.Exists(entry);
       if (!regex.IsMatch(entry) && !isFile) return null;
@@ -54,5 +54,5 @@
           case StartArgument.TOKEN: return new StartArgument(value);
           case HideStarterArgument.TOKEN: return new HideStarterArgument(value);
-          default: return null;
+          default: return new SimpleArgument(key, value);
         }
       } else return new OpenArgument(entry);
Index: branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/CrossDomainTracing.cs
===================================================================
--- branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/CrossDomainTracing.cs	(revision 16102)
+++ branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/CrossDomainTracing.cs	(revision 16102)
@@ -0,0 +1,97 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Diagnostics;
+using System.IO;
+using System.Reflection;
+
+namespace HeuristicLab.PluginInfrastructure {
+  public delegate void TraceWriterHandler(string message);
+
+  internal class SynchronizedTraceListener : TraceListener {
+    private TraceWriterHandler messageHandler;
+
+    public SynchronizedTraceListener(TraceWriterHandler writeHandler) {
+      messageHandler = writeHandler;
+    }
+
+    public override void Write(string message) {
+      messageHandler(message);
+    }
+
+    public override void WriteLine(string message) {
+      messageHandler(message + Environment.NewLine);
+    }
+  }
+
+  [Serializable]
+  public sealed class CrossDomainTracer : MarshalByRefObject {
+    private CrossDomainTracer remoteTracer;
+    private SynchronizedTraceListener remoteListener;
+
+    public CrossDomainTracer() {
+    }
+
+    public static void StartListening(AppDomain remoteDomain) {
+      var tracer = new CrossDomainTracer(remoteDomain);
+      Trace.Listeners.Add(new SynchronizedTraceListener(new TraceWriterHandler(Console.Write)));
+    }
+
+    public CrossDomainTracer(AppDomain farDomain) {
+      AppDomain.CurrentDomain.AssemblyResolve += new ResolveEventHandler(CurrentDomain_AssemblyResolve);
+      this.remoteTracer = farDomain.CreateInstanceFrom(Assembly.GetExecutingAssembly().Location, typeof(CrossDomainTracer).FullName).Unwrap() as CrossDomainTracer;
+      AppDomain.CurrentDomain.AssemblyResolve -= new ResolveEventHandler(CurrentDomain_AssemblyResolve);
+      if (remoteTracer != null) {
+        remoteTracer.StartListening(this);
+      }
+    }
+
+    public void StartListening(CrossDomainTracer farTracer) {
+      this.remoteTracer = farTracer;
+      this.remoteListener = new SynchronizedTraceListener(new TraceWriterHandler(Write));
+      Trace.Listeners.Add(this.remoteListener);
+    }
+
+    public void Write(string message) {
+      this.remoteTracer.RemoteWrite(message);
+    }
+
+    public void RemoteWrite(string message) {
+      Trace.Write(message);
+    }
+
+    Assembly CurrentDomain_AssemblyResolve(object sender, ResolveEventArgs args) {
+      try {
+        Assembly assembly = Assembly.Load(args.Name);
+        if (assembly != null) {
+          return assembly;
+        }
+      } catch { }
+
+      // Try to load by assembly fullname (path to file)
+      string[] Parts = args.Name.Split(',');
+      string File = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location) + "\\" + Parts[0].Trim() + ".dll";
+
+      return Assembly.LoadFrom(File);
+    }
+  }
+}
Index: branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj
===================================================================
--- branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 16101)
+++ branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 16102)
@@ -222,4 +222,5 @@
     <Compile Include="CommandLineArgumentHandling\Arguments\OpenArgument.cs" />
     <Compile Include="CommandLineArgumentHandling\Arguments\HideStarterArgument.cs" />
+    <Compile Include="CommandLineArgumentHandling\Arguments\SimpleArgument.cs" />
     <Compile Include="CommandLineArgumentHandling\Arguments\StartArgument.cs" />
     <Compile Include="CommandLineArgumentHandling\CommandLineArgument.cs" />
@@ -234,4 +235,5 @@
     <Compile Include="BaseClasses\ApplicationBase.cs" />
     <Compile Include="BaseClasses\PluginBase.cs" />
+    <Compile Include="CrossDomainTracing.cs" />
     <Compile Include="SandboxApplicationManager.cs" />
     <Compile Include="DefaultApplicationManager.cs" />
Index: branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginManager.cs
===================================================================
--- branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginManager.cs	(revision 16101)
+++ branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginManager.cs	(revision 16102)
@@ -129,4 +129,5 @@
         applicationManager.PrepareApplicationDomain(applications, plugins);
         OnApplicationStarted(new PluginInfrastructureEventArgs(appInfo));
+        CrossDomainTracer.StartListening(applicationDomain);
         applicationManager.Run(appInfo, args);
       }
Index: branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/Starter/SplashScreen.cs
===================================================================
--- branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/Starter/SplashScreen.cs	(revision 16101)
+++ branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/Starter/SplashScreen.cs	(revision 16102)
@@ -100,7 +100,10 @@
     private void SafeUpdateMessage(string msg) {
       try {
-        Invoke((Action<string>)UpdateMessage, msg);
-      }
-      catch (ObjectDisposedException) { }
+        if (InvokeRequired) {
+          Invoke((Action<string>)UpdateMessage, msg);
+        } else {
+          UpdateMessage(msg);
+        }
+      } catch (ObjectDisposedException) { }
     }
 
Index: branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/Starter/StarterForm.cs
===================================================================
--- branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/Starter/StarterForm.cs	(revision 16101)
+++ branches/2213_irace/HeuristicLab.PluginInfrastructure/3.3/Starter/StarterForm.cs	(revision 16102)
@@ -88,4 +88,29 @@
       : this() {
       arguments = CommandLineArgumentHandling.GetArguments(args);
+
+      InitializeComponent();
+      largeImageList.Images.Add(HeuristicLab.PluginInfrastructure.Resources.HeuristicLab.ToBitmap());
+      largeImageList.Images.Add(HeuristicLab.PluginInfrastructure.Resources.UpdateAvailable.ToBitmap());
+      smallImageList.Images.Add(HeuristicLab.PluginInfrastructure.Resources.HeuristicLab.ToBitmap());
+      smallImageList.Images.Add(HeuristicLab.PluginInfrastructure.Resources.UpdateAvailable.ToBitmap());
+      Text = "HeuristicLab " + AssemblyHelpers.GetFileVersion(GetType().Assembly);
+
+      string pluginPath = Path.GetFullPath(Application.StartupPath);
+      pluginManager = new PluginManager(pluginPath);
+      splashScreen = new SplashScreen(pluginManager, 1000);
+      splashScreen.VisibleChanged += new EventHandler(splashScreen_VisibleChanged);
+      if (arguments.All(x => !(x is HideStarterArgument)))
+        splashScreen.Show(this, "Loading HeuristicLab...");
+
+      if (CheckSavedStarterFormSettings()) {
+        Location = Settings.Default.StarterFormLocation;
+        Size = Settings.Default.StarterFormSize;
+        WindowState = Settings.Default.StarterFormWindowState;
+      }
+
+      pluginManager.DiscoverAndCheckPlugins();
+      UpdateApplicationsList();
+
+      CheckUpdatesAvailableAsync();
     }
 
@@ -320,5 +345,6 @@
 
     private void StartApplication(ApplicationDescription app, ICommandLineArgument[] args) {
-      splashScreen.Show("Loading " + app.Name);
+      if (args.All(x => !(x is HideStarterArgument)))
+        splashScreen.Show("Loading " + app.Name);
       Thread t = new Thread(delegate() {
         bool stopped = false;
